<HTML>
<HEAD>
  <link rel="icon" type="image/x-icon" href="qsieve.ico">
  <link rel="shortcut icon" type="image/x-icon" href="qsieve.ico">
  <TITLE>Qsieve: Status of current factorization</TITLE>
  <STYLE type="text/css">
   <!--
     BODY {background-color: black; color: white}
     .expanded { color:white; text-decoration:none; }
     .expanded_over { color:white; text-decoration:none; }
     .collapsed { color: #9a00fc; text-decoration:underline; }
     .collapsed_over { color:#9a50fc; text-decoration:none; }
    -->
  </STYLE>

  <script language="javascript">

   // -----------------------------------------------------------------
   // JavaScript helper functions written by Thorsten Reinecke, 2004-08
   // -----------------------------------------------------------------

   // get Cookie vaule for given id
   function GetCookieValue(id)
    {
      var value = "";
      if(document.cookie)
       {
         var s = document.cookie.indexOf(id+"=");
         if (s<0) return value;
         s = s + id.length + 1;
         var value = document.cookie.substring(s,document.cookie.length);
         if (value.indexOf(";")>=0) value = value.substring(0,value.indexOf(";"));
       }
      return value;
    }

   // store Cookie with value under the given id
   function SetCookieValue(id, value)
    {
      document.cookie = id+"="+value+";";
    }


   var collapsed_items = new Array();

   // ----------------------------------------------------
   // collapse a (menu-)object, semantic:
   // <div id='ID'> <div id='IDtitle'/> <div id='IDchild'/> </div>
   // collapse('ID') will
   //      a) set a cookie ID="collapsed"
   //      b) take some collapse-actions with IDtitle
   //      c) remove IDchild from ID
   // IDtitle need not to be necessarily a child of ID. 
   // ----------------------------------------------------
   function collapse(myid)
    {
      SetCookieValue(myid,"collapsed");
      if (s=document.getElementById(myid+"child"))
       {
         var h,t;
         h=document.getElementById(myid);
         if (t=document.getElementById(myid+"title")) t.className="collapsed";
         if (t=document.images[myid+"title"]) t.src="arrow-right.png";
         collapsed_items[myid]=h.removeChild(s);
       }
    }

   // ----------------------------------------------------
   // expand a (menu-)object, semantic:
   // <div id='ID'> <div id='IDtitle'/> <div id='IDchild'/> </div>
   // expand('ID') will
   //      a) set a cookie ID="expanded"
   //      b) take some expand-actions with IDtitle
   //      c) append IDchild to ID
   // IDtitle need not to be necessarily a child of ID. 
   // ----------------------------------------------------
   function expand(myid)
    {
      SetCookieValue(myid,"expanded");
      var t;
      if (t=document.getElementById(myid+"title")) t.className="expanded";
      if (t=document.images[myid+"title"]) t.src="arrow-down.png";
      if (!document.getElementById(myid+"child"))
       {
         var h=document.getElementById(myid);
         h.appendChild(collapsed_items[myid]);
         delete(collapsed_items[myid]);
       }
    }

   // toggle between collapsed and expanded
   function collapse_and_expand(myid)
    {
      var s=document.getElementById(myid+"child");
      if (s) collapse(myid); else expand(myid);
    }


   function my_MouseOut(myid)
    {
      var t,p;
      if (t=document.getElementById(myid+"title")) with (t)
       {
         if (className=="expanded_over")
          {
            className="expanded";
            if (p=document.images[myid+"title"]) p.src="arrow-down.png";
          }
         if (className=="collapsed_over")
          {
            className="collapsed";
            if (p=document.images[myid+"title"]) p.src="arrow-right.png";
          }
       }
    }

   var focused_id;

   function my_MouseOver(myid)
    {
      var t,p;
      if (t=document.getElementById(myid+"title")) with (t)
       {
         my_MouseOut(focused_id); focused_id=myid;
         if (className=="expanded")
          {
            className="expanded_over";
            if (p=document.images[myid+"title"]) p.src="arrow2-down.png";
          }
         if (className=="collapsed")
          {
            className="collapsed_over";
            if (p=document.images[myid+"title"]) p.src="arrow2-right.png";
          }
       }
    }


   function my_update()
    {
      // update the cookie settings and reload page
      location.reload();
    }

  </script> 

</HEAD>

<BODY>

<img align="middle" alt="Qsieve Logo &nbsp;"src="qsieve.png">

<?php

// a php4 script which connects to the qsieve XML status port
// and prints the status information
// written 2004-07-21 by Thorsten Reinecke
// last change: 2004-08-05 by Thorsten Reinecke

$host = "localhost"; // host on which qsieve server is running
$port = 12370; // qsieve XML status port
$file = "status.xml"; // if this connection fails, we use the content of this file instead


$map_array_S = array(
"LOGFILE" => "<H1> Log of latest factorizations </H1>",
"QSIEVESTATISTICS" => "<H1> Status of current factorization </H1>",
"NUMBERSECTION" => "<div><H2> Number to factorize </H2><div>",
"NUMBER" => "<div><H2> Number to factorize </H2><div>",
"ITEM" => "",
"FACTOR" => "<tr><td>",
"DIGITS" => " (",
"TABLE" => "<div> <table border=\"1\" style=\"width: 100%;\"> <tbody>",
"TR" => "<tr>",
"TD" => "<td>",
"STATUSINFO" => "<div><H2> Current server status (total) </H2>\n<table border=\"0\"><tbody>",
"RELFOUND" => "<tr><td>static relations found so far:</td><td>",
"RELDISTRIBUTION" => " with distribution {",
"RELTOTAL" => "<tr><td>size of factorbase:</td><td> ",
"SLPFOUND" => "<tr><td>dynamic relations actively found:</td><td>",
"SLPTOTAL" => "<tr><td>single large primes (total):</td><td>",
"DLPTOTAL" => "<tr><td>double large primes found so far:</td><td>",
"DLP2SLP" => "<tr><td>DLP splitted to SLP relations:</td><td>",
"DLP2STATIC" => "<tr><td>DLP special hits (eg. quadratic DLP):</td><td>",
"DLP2CYCLE" => "<tr><td>DLP cycle splits to static relations:</td><td>",
"PERCENTAGEDONE" => "<tr><td>done:</td><td>"
);

$map_array_E = array(
"QSIEVESTATISTICS" => "<br><hr>".strftime("%Y-%m-%d, %X (%Z)", time())." <br>",
"NUMBERSECTION" => "</div></div>",
"NUMBER" => "</div></div>",
"ITEM" => "<br>",
"FACTOR" => "</td></tr>",
"DIGITS" => ") ",
"TABLE" => "</tbody> </table> </div>\n",
"TR" => "</TR>",
"TD" => "</TD>",
"NETCLIENT" => "</tr>",
"STATUSINFO" => "</tbody></table></div>",
"RELFOUND" => "</td></tr>",
"RELDISTRIBUTION" => "}",
"RELTOTAL" => "</td></tr>",
"SLPFOUND" => "</td></tr>",
"SLPTOTAL" => "</td></tr>",
"DLPTOTAL" => "</td></tr>",
"DLP2SLP" => "</td></tr>",
"DLP2STATIC" => "</td></tr>",
"DLP2CYCLE" => "</td></tr>",
"PERCENTAGEDONE" => "</td></tr>"
);


$Time = strftime("%Y-%m-%d, %X (%Z)", time());
$Version = "unknown";
$JSActionString = "";
$lfd_nr = 0;


function addCookieAction($item)
{
  global $JSActionString;
  $JSActionString .= "if (GetCookieValue('$item')==\"expanded\") expand('$item'); else collapse('$item');\n";
}

function DivAction($item)
{
  echo "<div id=\"$item\" style=\"cursor:pointer;\" ";
  echo "OnClick=\"javascript:collapse_and_expand('$item');javascript:my_MouseOver('$item');\" ";
  echo "OnMouseOver=\"javascript:my_MouseOver('$item')\" ";
  echo "OnMouseOut=\"javascript:my_MouseOut('$item')\" >\n";
}

function startElement($parser, $name, $attribs)
{
  global $map_array_S;
  global $Time;
  global $Version;
  global $JSActionString;
  global $lfd_nr;

  $lfd_nr+=1; // count elements
  // This is not a perfect solution for creating unique IDs if cookies are
  // generated for dynamic content! For expamle XML stack depth is not
  // considered!  So if new dynamic content is generated (eg. more table
  // entries than in the former XML document), the IDs get shifted and
  // do not reference the original objects anymore.

  switch ($name)
   {
     case "QSIEVESTATISTICS":
       $Time=$attribs['TIME'];
       $Version=$attribs['VERSION'];
       if (isset($map_array_S[$name])) echo "$map_array_S[$name]";
       else echo " ($name start) ";
      break;

     case "TABLE":
      if ($attribs['CONTENT'] == "NETCLIENTS")
       {
         $item=str_replace(" ","",$attribs['CONTENT']).$lfd_nr; $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\">Status of connected net-clients</H2>\n";
         echo "<table id=\"$item_child\" border=\"2\" style=\"width: 100%;\"> <tbody align=\"center\">";
         echo "<tr>";
         echo "<td>client</td> ";
         echo "<td>first connect</td> ";
         echo "<td>last connect</td> ";
         echo "<td>static relations</td> ";
         echo "<td>dynamic relations</td> ";
         echo "<td>DLP relations</td> ";
         echo "<td>rate</td> ";
         echo "</tr>";
         break;
       }
      if ($attribs['CONTENT'] == "FACTORS")
       {
         $item=str_replace(" ","",$attribs['CONTENT']).$lfd_nr; $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\">Recently found factors</H2>\n";
         echo "<table id=\"$item_child\" border=\"0\"> <tbody align=\"center\">";
         break;
       }
      if (isset($attribs['CONTENT']))
       {
         $item=str_replace(" ","",$attribs['CONTENT']).$lfd_nr; $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\"> Table of ". $attribs['CONTENT']."</H2>\n";
         echo "<table id=\"$item_child\" border=\"1\"> <tbody align=\"center\">";
         break;
       }
      if (isset($map_array_S[$name])) echo "$map_array_S[$name]";
      else echo " ($name start) ";
      break;

     case "NETCLIENT":
       echo "<tr>";
       echo "<td>$attribs[HOSTNAME]</td> ";
       echo "<td>$attribs[FIRSTCONNECT]</td> ";
       echo "<td>$attribs[LASTCONNECT]</td> ";
       echo "<td>$attribs[STATICRELATIONS]</td> ";
       echo "<td>$attribs[DYNAMICRELATIONS]</td> ";
       echo "<td>$attribs[DLPRELATIONS]</td> ";
       echo "<td>$attribs[PERCENTAGE]</td>";
      break;


     case "NUMBERSECTION":
       {
         $item=str_replace(" ","",$attribs['CONTENT']).$lfd_nr; $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\"> Number to factorize </H2>\n";
         echo "<div id=\"$item_child\">";
         break;
       }

     case "ITEM":
       {
         if (isset($attribs['CONTENT'])) echo $attribs['CONTENT'];
         break;
       }

     case "STATUSINFO":
       {
         $item=str_replace(" ","",$attribs['CONTENT']).$lfd_nr; $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\"> Current server status (total) </H2>\n";
         echo "<table id=\"$item_child\" border=\"0\"><tbody>";
         break;
       }

     default:
      if (isset($map_array_S[$name])) echo "$map_array_S[$name]";
      else echo " ($name start) ";
   }
}

function endElement($parser, $name)
{
  global $map_array_E;
  global $Time;
  global $Version;

  switch ($name)
   {
     case "QSIEVESTATISTICS":
       echo "\n<br><hr>";
       echo "Faktorisierungsprogramm qsieve-".$Version.", ".$Time;
       echo "<br>";
      break;

    default:
     if (isset($map_array_E[$name]))
      {
       echo "$map_array_E[$name]";
      } else echo " ($name end) <br>";
   }
}

function characterData($parser, $data)
{
  echo $data;
}


$xml_parser = xml_parser_create();
xml_set_element_handler($xml_parser, "startElement", "endElement");
xml_set_character_data_handler($xml_parser, "characterData");


if (!($fp = fsockopen($host, $port, $errno, $errstr, 30)))
 {
   echo "$errstr ($errno)<br />\n";
   echo "could not connetct to qsieve XML status server<br />\n";
   if (!($fp = fopen($file, "r")))
    {
      echo "no statistical information available<br />\n";
      die("failed to access qsieve XML status information");
    }
}


while ($data = fread($fp, 4096))
{
   if (!xml_parse($xml_parser, $data, feof($fp)))
    {
      die(sprintf("XML error: %s at line %d",
                   xml_error_string(xml_get_error_code($xml_parser)),
                   xml_get_current_line_number($xml_parser)));
    }
}

fclose($fp);
xml_parser_free($xml_parser);


// now follows the generation of some JavaScript code for
// collapsing or expanding the view of objects (tables, etc.)
echo "\n\n";
echo "<script language=\"javascript\">\n";
echo $JSActionString;
// if we want auto-update, enable this:
//echo "setInterval('my_update();',5*60*1000);\n";
echo "</script>\n";
echo "\n";

?>

<img border="off" name="update" alt="update" align="right" src="update.png"
 OnMouseOver="document.images['update'].src='update2.png'"
 OnMouseOut="document.images['update'].src='update.png'"
 OnClick="javascript:my_update()" >

</BODY>
</HTML>
