<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
 <HTML>
 <HEAD>
  <TITLE>Qsieve Factorization Status Pages</TITLE>
 </HEAD>
 <BODY>
 <xsl:apply-templates />
 </BODY>
 </HTML>
</xsl:template>

<xsl:template match="LOGFILE">
 <H1> Log of latest factorizations </H1>
 <xsl:apply-templates />
 <br/><hr/>
</xsl:template>

<xsl:template match="QSIEVESTATISTICS">
 <H1> Status of current factorization </H1>
 <xsl:apply-templates />
 <br/><hr/>
 Faktorisierungsprogramm qsieve-<xsl:value-of select="@VERSION" />, <xsl:value-of select="@TIME" />
</xsl:template>

<xsl:template match="NUMBER">
 <H2> Number to factorize: </H2>
 <xsl:apply-templates />
</xsl:template>

<xsl:template match="NUMBERSECTION">
 <H2> Number to factorize: </H2>
 <xsl:apply-templates />
</xsl:template>

<xsl:template match="ITEM">
 <xsl:variable name="content" select="@CONTENT" />
 <xsl:value-of select="$content"/>
 <xsl:apply-templates />
 <br/>
</xsl:template>


<xsl:template match="FACTOR">
 <tr><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>


<xsl:template match="TABLE">

 <xsl:variable name="content" select="@CONTENT" />
 <xsl:choose>
  <xsl:when test="$content='NETCLIENTS'" >
  <H2>Status of connected net-clients:</H2>
  <table border="2" style="width: 100%;"> <tbody align="center">
  <tr>
  <td>client</td>
  <td>first connect</td>
  <td>last connect</td>
  <td>static relations</td>
  <td>dynamic relations</td>
  <td>DLP relations</td>
  <td>rate</td>
  </tr>
  <xsl:apply-templates />
  </tbody> </table>
 </xsl:when>
 <xsl:when test="$content='FACTORS'">
  <H2>recently found factors:</H2>
  <table border="0" > <tbody align="center">
  <xsl:apply-templates />
  </tbody> </table>
 </xsl:when>
 <xsl:when test="string-length($content) &gt; 0">
  <H2>Table of <xsl:value-of select="$content"/>:</H2>
  <table border="1" > <tbody align="center">
  <xsl:apply-templates />
  </tbody> </table>
 </xsl:when>

 <xsl:otherwise>
  <table border="1" style="width: 100%;"> <tbody>
  <xsl:apply-templates />
  </tbody> </table>
 </xsl:otherwise>

</xsl:choose>
</xsl:template>


<xsl:template match="tr">
 <tr>
 <xsl:apply-templates />
 </tr>
</xsl:template>

<xsl:template match="td">
 <td>
 <xsl:apply-templates />
 </td>
</xsl:template>


<xsl:template match="NETCLIENT">
 <tr>
 <td><xsl:value-of select="@HOSTNAME" /> </td>
 <td><xsl:value-of select="@FIRSTCONNECT" /> </td>
 <td><xsl:value-of select="@LASTCONNECT" /> </td>
 <td><xsl:value-of select="@STATICRELATIONS" /> </td>
 <td><xsl:value-of select="@DYNAMICRELATIONS" /> </td>
 <td><xsl:value-of select="@DLPRELATIONS" /> </td>
 <td><xsl:value-of select="@PERCENTAGE" /> </td>
 </tr>
 <xsl:apply-templates />
</xsl:template>


<xsl:template match="STATUSINFO">
 <H2> Current server status (total): </H2>
 <table border="0"><tbody>
 <xsl:apply-templates />
 </tbody></table>
</xsl:template>

<xsl:template match="RELFOUND">
 <tr><td>static relations found so far:</td><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>

<xsl:template match="RELDISTRIBUTION">
 with distribution {
 <xsl:apply-templates />
 }
</xsl:template>

<xsl:template match="RELTOTAL">
 <tr><td>size of factorbase:</td><td> 
 <xsl:apply-templates />
 </td></tr>
</xsl:template>

<xsl:template match="SLPFOUND">
 <tr><td>dynamic relations actively found:</td><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>

<xsl:template match="SLPTOTAL">
 <tr><td>single large primes (total):</td><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>

<xsl:template match="DLPTOTAL">
 <tr><td>double large primes found so far:</td><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>

<xsl:template match="DLP2SLP">
 <tr><td>DLP splitted to SLP relations:</td><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>

<xsl:template match="DLP2STATIC">
 <tr><td>DLP special hits (eg. quadratic DLP):</td><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>

<xsl:template match="DLP2CYCLE">
 <tr><td>DLP cycle splits to static relations:</td><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>

<xsl:template match="PERCENTAGEDONE">
 <tr><td>done:</td><td>
 <xsl:apply-templates />
 </td></tr>
</xsl:template>


</xsl:stylesheet>
